Index: .gitignore
===================================================================
--- .gitignore	(revision de18326f12c18fd92f275bf46bca509343b79063)
+++ .gitignore	(revision f93cc347fb2a2bbbda7429640ecb42470315a62d)
@@ -15,4 +15,5 @@
 autom4te.cache
 barnowl.bin
+tester.bin
 zcrypt
 blib
@@ -30,5 +31,4 @@
 owl_prototypes.h
 owl_prototypes.h.new
-perl_tester
 perlglue.c
 perlwrap.c
Index: Makefile.am
===================================================================
--- Makefile.am	(revision 5aa33fd73dce2c8d6c88559e62cd1ae78ef4a36d)
+++ Makefile.am	(revision 9d27ee8678625706f5eead430bbe2f956fc1eb41)
@@ -1,3 +1,4 @@
 ACLOCAL_AMFLAGS = -I m4
+CFLAGS += $(EXTRA_CFLAGS)
 
 GIT_DESCRIPTION := $(if $(wildcard .git),$(shell git describe --match='barnowl-*' HEAD 2>/dev/null))
@@ -18,4 +19,7 @@
      $(GEN_C) $(GEN_H)
 
+man_MANS = doc/barnowl.1
+doc_DATA = doc/intro.txt doc/advanced.txt
+
 barnowl_bin_LDADD = libfaim/libfaim.a
 
@@ -35,5 +39,5 @@
            $(GIT_FLAGS)
 
-BASE_SRCS=list.c message.c mainwin.c popwin.c zephyr.c messagelist.c \
+CODELIST_SRCS=list.c message.c mainwin.c popwin.c zephyr.c messagelist.c \
      commands.c global.c text.c fmtext.c editwin.c util.c logging.c \
      perlconfig.c keys.c functions.c zwrite.c viewwin.c help.c filter.c \
@@ -41,6 +45,10 @@
      keypress.c keymap.c keybinding.c cmd.c context.c \
      aim.c buddy.c buddylist.c style.c errqueue.c \
-     zbuddylist.c popexec.c obarray.c select.c wcwidth.c \
-     glib_compat.c filterproc.c
+     zbuddylist.c popexec.c select.c wcwidth.c \
+     glib_compat.c mainpanel.c msgwin.c sepbar.c
+
+NORMAL_SRCS = filterproc.c window.c windowcb.c
+
+BASE_SRCS = $(CODELIST_SRCS) $(NORMAL_SRCS)
 
 GEN_C = varstubs.c perlglue.c
@@ -64,5 +72,5 @@
 	$(AM_V_GEN)perl $< $(sort $(filter-out $<,$+)) > $@
 
-owl_prototypes.h.new: codelist.pl varstubs.c $(BASE_SRCS)
+owl_prototypes.h.new: codelist.pl varstubs.c $(CODELIST_SRCS)
 	$(AM_V_GEN)perl $< $(sort $(filter-out $<,$+)) > $@
 
Index: README
===================================================================
--- README	(revision 62c91c1f0cea6cc5450131f07cc577f8d54ba828)
+++ README	(revision aeadc748f353cd0be4ebfa805d85577c9c7498fa)
@@ -1,8 +1,7 @@
 BarnOwl - owl, with more ponies
 
+Source is freely available from http://github.com/barnowl/barnowl/
+
 Based on owl 2.1.11, by James Kretchmar (http://www.ktools.org)
-
-This project is a work in progress.
-We guarantee no stability of form or function.
 
 Notes:
Index: cmd.c
===================================================================
--- cmd.c	(revision 8d4b521bc5864ca28d5d575dc461859580d4cf28)
+++ cmd.c	(revision 1cc9b61526eafe04cf53d24712f11ab9ac0fbb8b)
@@ -52,4 +52,5 @@
   cmd = owl_malloc(sizeof(owl_cmd));
   owl_cmd_create_alias(cmd, alias_from, alias_to);
+  owl_perlconfig_new_command(cmd->name);
   owl_dict_insert_element(cd, cmd->name, cmd, (void (*)(void *))owl_cmd_delete);
   return(0);
@@ -73,4 +74,6 @@
   } else if (NULL != (cmd = owl_dict_find_element(cd, argv[0]))) {
     retval = owl_cmd_execute(cmd, cd, ctx, argc, argv, buff);
+    /* redraw the sepbar; TODO: don't violate layering */
+    owl_global_sepbar_dirty(&g);
   } else {
     owl_function_makemsg("Unknown command '%s'.", buff);
@@ -89,5 +92,4 @@
   if (argc < 0) {
     owl_free(tmpbuff);
-    sepbar(NULL);
     owl_function_makemsg("Unbalanced quotes");
     return NULL;
@@ -104,5 +106,4 @@
   owl_parse_delete(argv, argc);
   owl_free(tmpbuff);
-  sepbar(NULL);
   return retval;
 }
Index: commands.c
===================================================================
--- commands.c	(revision 7ba9e0de5c3ae61398fc37bbee797b006d03f947)
+++ commands.c	(revision 987cf3f48057443b84ecf140854129cf1a6cbbdc)
@@ -106,5 +106,5 @@
   OWLCMD_ARGS("zwrite", owl_command_zwrite, OWL_CTX_INTERACTIVE,
 	      "send a zephyr",
-	      "zwrite [-n] [-C] [-c class] [-i instance] [-r realm] [-O opcde] [<user> ...] [-m <message...>]",
+	      "zwrite [-n] [-C] [-c class] [-i instance] [-r realm] [-O opcode] [<user> ...] [-m <message...>]",
 	      "Zwrite send a zephyr to the one or more users specified.\n\n"
 	      "The following options are available:\n\n"
@@ -136,7 +136,7 @@
 	      "Send a local message.\n"),
 
-  OWLCMD_ARGS("zcrypt", owl_command_zcrypt, OWL_CTX_INTERACTIVE,
+  OWLCMD_ARGS("zcrypt", owl_command_zwrite, OWL_CTX_INTERACTIVE,
 	      "send an encrypted zephyr",
-	      "zcrypt [-n] [-C] [-c class] [-i instance] [-r realm] [-O opcde] [-m <message...>]\n",
+	      "zcrypt [-n] [-C] [-c class] [-i instance] [-r realm] [-O opcode] [-m <message...>]\n",
 	      "Behaves like zwrite but uses encryption.  Not for use with\n"
 	      "personal messages\n"),
@@ -148,5 +148,5 @@
 	      "allow editing.\n\n"
 	      "If 'sender' is specified, reply to the sender.\n\n"
-	      "If 'all' or no args are specified, reply publically to the\n"
+	      "If 'all' or no args are specified, reply publicly to the\n"
 	      "same class/instance for non-personal messages and to the\n"
 	      "sender for personal messages.\n\n"
@@ -266,5 +266,5 @@
 	      "zpunt <class> <instance> [recipient]\n"
 	      "zpunt <instance>",
-	      "The zpunt command will supress message to the specified\n"
+	      "The zpunt command will suppress messages to the specified\n"
 	      "zephyr triplet.  In the second usage messages are suppressed\n"
 	      "for class MESSAGE and the named instance.\n\n"
@@ -283,5 +283,5 @@
 	      "punt <filter-text>",
 	      "punt <filter-text (multiple words)>\n"
-	      "The punt command will supress message to the specified\n"
+	      "The punt command will suppress messages to the specified\n"
 	      "filter\n\n"
 	      "SEE ALSO:  unpunt, zpunt, show zpunts\n"),
@@ -586,5 +586,5 @@
               "name style after the -s argument.\n"
 	      "\n"
-	      "The other usages listed above are abbreivated forms that simply set\n"
+	      "The other usages listed above are abbreviated forms that simply set\n"
 	      "the filter of the current view. The -d option allows you to write a\n"
               "filter expression that will be dynamically created by owl and then\n"
@@ -594,5 +594,5 @@
   OWLCMD_ARGS("smartnarrow", owl_command_smartnarrow, OWL_CTX_INTERACTIVE,
 	      "view only messages similar to the current message",
-	      "smartnarrow [-i | --instance]  [-r | --relatde]",
+	      "smartnarrow [-i | --instance]  [-r | --related]",
 	      "If the curmsg is a personal message narrow\n"
 	      "   to the conversation with that user.\n"
@@ -614,5 +614,5 @@
 	      "   message, the filter is to that instance.\n"
 	      "If the curmsg is a class message, the filter is that class.\n"
-	      "If the curmsg is a class message and '-i' is specied\n"
+	      "If the curmsg is a class message and '-i' is specified\n"
 	      "    the filter is to that class and instance.\n"),
 
@@ -674,5 +674,5 @@
 	      "for formatting messages.\n\n"
 	      "Show variables will list the names of all variables.\n\n"
-	      "Show errors will show a list of errors ecountered by Owl.\n\n"
+	      "Show errors will show a list of errors encountered by Owl.\n\n"
 	      "SEE ALSO: filter, view, alias, bindkey, help\n"),
   
@@ -743,5 +743,5 @@
 	      "set the search highlight string without searching",
 	      "setsearch <string>",
-	      "The setsearch command highlights all occurences of its\n"
+	      "The setsearch command highlights all occurrences of its\n"
           "argument and makes it the default argument for future\n"
           "search commands, but does not move the cursor.  With\n"
@@ -1371,5 +1371,4 @@
 {
   owl_function_full_redisplay();
-  owl_global_set_needrefresh(&g);
 }
 
@@ -1387,6 +1386,4 @@
 {
   owl_global_set_rightshift(&g, shift);
-  owl_mainwin_redisplay(owl_global_get_mainwin(&g));
-  owl_global_set_needrefresh(&g);
 }
 
@@ -1914,5 +1911,5 @@
 char *owl_command_zwrite(int argc, const char *const *argv, const char *buff)
 {
-  owl_zwrite z;
+  owl_zwrite *z;
 
   if (!owl_global_is_havezephyr(&g)) {
@@ -1921,16 +1918,21 @@
   }
   /* check for a zwrite -m */
-  owl_zwrite_create_from_line(&z, buff);
-  if (owl_zwrite_is_message_set(&z)) {
-    owl_function_zwrite(buff, NULL);
-    owl_zwrite_cleanup(&z);
-    return (NULL);
-  }
-  owl_zwrite_cleanup(&z);
+  z = owl_zwrite_new(buff);
+  if (!z) {
+    owl_function_error("Error in zwrite arguments");
+    return NULL;
+  }
+
+  if (owl_zwrite_is_message_set(z)) {
+    owl_function_zwrite(z, NULL);
+    owl_zwrite_delete(z);
+    return NULL;
+  }
 
   if (argc < 2) {
+    owl_zwrite_delete(z);
     owl_function_makemsg("Not enough arguments to the zwrite command.");
   } else {
-    owl_function_zwrite_setup(buff);
+    owl_function_zwrite_setup(z);
   }
   return(NULL);
@@ -2022,29 +2024,4 @@
 }
 
-char *owl_command_zcrypt(int argc, const char *const *argv, const char *buff)
-{
-  owl_zwrite z;
-
-  if (!owl_global_is_havezephyr(&g)) {
-    owl_function_makemsg("Zephyr is not available");
-    return(NULL);
-  }
-  /* check for a zcrypt -m */
-  owl_zwrite_create_from_line(&z, buff);
-  if (owl_zwrite_is_message_set(&z)) {
-    owl_function_zcrypt(buff, NULL);
-    owl_zwrite_cleanup(&z);
-    return (NULL);
-  }
-  owl_zwrite_cleanup(&z);
-
-  if (argc < 2) {
-    owl_function_makemsg("Not enough arguments to the zcrypt command.");
-  } else {
-    owl_function_zwrite_setup(buff);
-  }
-  return(NULL);
-}
-
 char *owl_command_reply(int argc, const char *const *argv, const char *buff)
 {
@@ -2184,8 +2161,4 @@
       argc--;
       argv++;
-    } else if (!strcmp(argv[0], "-r")) {
-      const char *foo;
-      foo=owl_function_create_negative_filter(owl_view_get_filtname(owl_global_get_current_view(&g)));
-      owl_function_change_currentview_filter(foo);
     } else if (!strcmp(argv[0], "-s")) {
       if (argc<2) {
@@ -2717,5 +2690,4 @@
   }
 
-  owl_global_set_needrefresh(&g);
   owl_global_pop_context(&g);
 
@@ -2738,6 +2710,4 @@
     owl_editwin_clear(e);
     owl_editwin_insert_string(e, ptr);
-    owl_editwin_redisplay(e);
-    owl_global_set_needrefresh(&g);
   } else {
     owl_function_beep();
@@ -2755,6 +2725,4 @@
     owl_editwin_clear(e);
     owl_editwin_insert_string(e, ptr);
-    owl_editwin_redisplay(e);
-    owl_global_set_needrefresh(&g);
   } else {
     owl_function_beep();
@@ -2766,6 +2734,4 @@
   buff = skiptokens(buff, 1);
   owl_editwin_insert_string(e, buff);
-  owl_editwin_redisplay(e);
-  owl_global_set_needrefresh(&g);  
   return NULL;
 }
@@ -2782,5 +2748,4 @@
   owl_global_set_typwin_inactive(&g);
   owl_global_pop_context(&g);
-  owl_global_set_needrefresh(&g);
 
   owl_editwin_do_callback(e);
@@ -2804,7 +2769,6 @@
 void owl_command_popless_quit(owl_viewwin *vw)
 {
+  owl_viewwin_cleanup(vw);
   owl_popwin_close(owl_global_get_popwin(&g));
   owl_global_pop_context(&g);
-  owl_viewwin_cleanup(vw);
-  owl_global_set_needrefresh(&g);
-}
+}
Index: configure.ac
===================================================================
--- configure.ac	(revision 263320f0be9d4016164837d2de7310b687a6f076)
+++ configure.ac	(revision 04af908ca44749f771ae778a21315327b6d24135)
@@ -35,17 +35,24 @@
   [with_zephyr=check])
 
+AC_ARG_WITH([krb4],
+  AS_HELP_STRING([--with-krb4],
+                 [Build with kerberos IV]))
+
 AS_IF([test "x$with_zephyr" != xno],
-  [AC_MSG_CHECKING([for Kerberos IV])
-   AS_IF([krb5-config krb4 --libs >/dev/null 2>&1],
-     [AC_MSG_RESULT([yes])
-      AC_DEFINE([HAVE_KERBEROS_IV], [1], [Define if you have kerberos IV])
-      CFLAGS="${CFLAGS} `krb5-config krb4 --cflags`"
-      LIBS="${LIBS} `krb5-config krb4 --libs`"
-     ],
-     [AC_MSG_RESULT([no])
-      PKG_CHECK_MODULES([LIBCRYPTO], [libcrypto])
-      CFLAGS="${CFLAGS} ${LIBCRYPTO_CFLAGS}"
-      LIBS="${LIBS} ${LIBCRYPTO_LIBS}"
-     ])
+  [AS_IF([test "x$with_krb4" != "xno"],
+   [AC_MSG_CHECKING([for Kerberos IV])
+    AS_IF([krb5-config krb4 --libs >/dev/null 2>&1],
+      [AC_MSG_RESULT([yes])
+       AC_DEFINE([HAVE_KERBEROS_IV], [1], [Define if you have kerberos IV])
+       CFLAGS="${CFLAGS} `krb5-config krb4 --cflags`"
+       LIBS="${LIBS} `krb5-config krb4 --libs`"
+      ],
+      [AC_MSG_RESULT([no])
+       AS_IF([test "x$with_krb4" = "xyes"],
+             [AC_MSG_ERROR([Kerberos IV requested but not found])])
+       PKG_CHECK_MODULES([LIBCRYPTO], [libcrypto])
+       CFLAGS="${CFLAGS} ${LIBCRYPTO_CFLAGS}"
+       LIBS="${LIBS} ${LIBCRYPTO_LIBS}"
+     ])])
    AC_CHECK_LIB([zephyr], [ZGetSender],
    [LIBS="$LIBS -lzephyr"
@@ -108,5 +115,5 @@
 
 dnl Add CFLAGS and LDFLAGS for glib-2.0
-PKG_CHECK_MODULES(GLIB,glib-2.0)
+PKG_CHECK_MODULES(GLIB,[glib-2.0 gobject-2.0])
 
 AC_MSG_NOTICE([Adding glib-2.0 CFLAGS ${GLIB_CFLAGS}])
@@ -131,4 +138,6 @@
                                  test "$HAVE_DES_ECB_ENCRYPT"])
 
+CFLAGS="$CFLAGS -D_XOPEN_SOURCE"
+
 AC_SUBST([LIBFAIM_CFLAGS])
 
Index: context.c
===================================================================
--- context.c	(revision 2a17b635c6895121650446d2529f46d7e291a486)
+++ context.c	(revision 07b59ea301a55bf3db1724aa9571e7048fe89857)
@@ -9,4 +9,5 @@
   ctx->mode = OWL_CTX_STARTUP;
   ctx->data = NULL;
+  ctx->cursor = NULL;
   return 0;
 }
Index: editwin.c
===================================================================
--- editwin.c	(revision 9d7a7205d6c9cbea0e8999e4c350440f8ef5fef8)
+++ editwin.c	(revision 3f11c00e8b62c8bf4c5a6b6f51f8f3e12cfd8fcf)
@@ -28,5 +28,7 @@
   int cursorx;
   int winlines, wincols, fillcol, wrapcol;
-  WINDOW *curswin;
+  owl_window *win;
+  gulong repaint_id;
+  gulong resized_id;
   int style;
   int lock;
@@ -40,4 +42,6 @@
 };
 
+static void oe_set_window(owl_editwin *e, owl_window *w, int winlines, int wincols);
+static void oe_redraw(owl_window *win, WINDOW *curswin, void *user_data);
 static void oe_reframe(owl_editwin *e);
 static void oe_save_excursion(owl_editwin *e, oe_excursion *x);
@@ -58,4 +62,6 @@
 static char *oe_chunk(owl_editwin *e, int start, int end);
 static void oe_destroy_cbdata(owl_editwin *e);
+static void oe_dirty(owl_editwin *e);
+static void oe_window_resized(owl_window *w, owl_editwin *e);
 
 #define INCR 4096
@@ -73,4 +79,8 @@
 void owl_editwin_delete(owl_editwin *e)
 {
+  if (e->win) {
+    g_signal_handler_disconnect(e->win, e->repaint_id);
+    g_signal_handler_disconnect(e->win, e->resized_id);
+  }
   owl_free(e->buff);
   owl_free(e->killbuf);
@@ -91,4 +101,5 @@
   }
   e->index = index;
+  oe_dirty(e);
 }
 
@@ -105,5 +116,4 @@
 
 static void _owl_editwin_init(owl_editwin *e,
-                              WINDOW *win,
                               int winlines,
                               int wincols,
@@ -130,23 +140,27 @@
     e->style=OWL_EDITWIN_STYLE_MULTILINE;
   }
-  owl_editwin_set_curswin(e, win, winlines, wincols);
   e->lock=0;
   e->dotsend=0;
   e->echochar='\0';
-
-  if (win) werase(win);
-}
-
-owl_editwin *owl_editwin_new(WINDOW *win, int winlines, int wincols, int style, owl_history *hist)
+}
+
+owl_editwin *owl_editwin_new(owl_window *win, int winlines, int wincols, int style, owl_history *hist)
 {
   owl_editwin *e = owl_editwin_allocate();
 
-  _owl_editwin_init(e, win, winlines, wincols, style, hist);
+  _owl_editwin_init(e, winlines, wincols, style, hist);
+  oe_set_window(e, win, winlines, wincols);
   return e;
 }
 
-void owl_editwin_set_curswin(owl_editwin *e, WINDOW *w, int winlines, int wincols)
-{
-  e->curswin=w;
+static void oe_window_resized(owl_window *w, owl_editwin *e)
+{
+  /* update the sizes */
+  owl_window_get_position(w, &e->winlines, &e->wincols, NULL, NULL);
+}
+
+static void oe_set_window(owl_editwin *e, owl_window *w, int winlines, int wincols)
+{
+  e->win=w;
   e->winlines=winlines;
   e->wincols=wincols;
@@ -156,4 +170,9 @@
   else
     e->wrapcol = 0;
+  if (e->win) {
+    e->repaint_id = g_signal_connect(w, "redraw", G_CALLBACK(oe_redraw), e);
+    e->resized_id = g_signal_connect(w, "resized", G_CALLBACK(oe_window_resized), e);
+    owl_window_dirty(e->win);
+  }
 }
 
@@ -165,9 +184,5 @@
 {
   e->echochar=ch;
-}
-
-WINDOW *owl_editwin_get_curswin(owl_editwin *e)
-{
-  return(e->curswin);
+  oe_dirty(e);
 }
 
@@ -239,5 +254,5 @@
   e->lock=e->bufflen;
   oe_set_index(e, e->lock);
-  owl_editwin_redisplay(e);
+  oe_dirty(e);
 }
 
@@ -265,5 +280,5 @@
 
   owl_free(e->buff);
-  _owl_editwin_init(e, e->curswin, e->winlines, e->wincols, e->style, e->hist);
+  _owl_editwin_init(e, e->winlines, e->wincols, e->style, e->hist);
 
   if (lock > 0) {
@@ -286,4 +301,5 @@
 {
   e->topindex = -1;
+  oe_dirty(e);
 }
 
@@ -467,28 +483,30 @@
 
   oe_restore_excursion(e, &x);
-}
-
-static void oe_addnec(owl_editwin *e, int count)
+  oe_dirty(e);
+}
+
+static void oe_addnec(owl_editwin *e, WINDOW *curswin, int count)
 {
   int i;
 
   for (i = 0; i < count; i++)
-    waddch(e->curswin, e->echochar);
-}
-
-static void oe_mvaddnec(owl_editwin *e, int y, int x, int count)
-{
-  wmove(e->curswin, y, x);
-  oe_addnec(e, count);
+    waddch(curswin, e->echochar);
+}
+
+static void oe_mvaddnec(owl_editwin *e, WINDOW *curswin, int y, int x, int count)
+{
+  wmove(curswin, y, x);
+  oe_addnec(e, curswin, count);
 }
 
 /* regenerate the text on the curses window */
-void owl_editwin_redisplay(owl_editwin *e)
+static void oe_redraw(owl_window *win, WINDOW *curswin, void *user_data)
 {
   int x = -1, y = -1, t, hard;
   int line, index, lineindex, times = 0;
+  owl_editwin *e = user_data;
 
   do {
-    werase(e->curswin);
+    werase(curswin);
 
     if (e->topindex == -1 || e->index < e->topindex)
@@ -505,22 +523,22 @@
       if (index - lineindex) {
 	if (!e->echochar)
-	  mvwaddnstr(e->curswin, line, 0,
+	  mvwaddnstr(curswin, line, 0,
 		     e->buff + lineindex,
 		     index - lineindex);
 	else {
 	  if(lineindex < e->lock) {
-	    mvwaddnstr(e->curswin, line, 0,
+	    mvwaddnstr(curswin, line, 0,
 		       e->buff + lineindex,
 		       MIN(index - lineindex,
 			   e->lock - lineindex));
 	    if (e->lock < index)
-	      oe_addnec(e,
+	      oe_addnec(e, curswin,
 			oe_region_width(e, e->lock, index,
 					oe_region_width(e, lineindex, e->lock, 0)));
 	  } else
-	    oe_mvaddnec(e, line, 0, oe_region_width(e, lineindex, index, 0));
+	    oe_mvaddnec(e, curswin, line, 0, oe_region_width(e, lineindex, index, 0));
 	}
         if (!hard)
-          waddch(e->curswin, '\\');
+          waddch(curswin, '\\');
       }
       line++;
@@ -531,5 +549,5 @@
   } while(x == -1 && times < 3);
 
-  wmove(e->curswin, y, x);
+  wmove(curswin, y, x);
   e->cursorx = x;
 }
@@ -624,4 +642,6 @@
   if (start <= e->topindex)
     owl_editwin_recenter(e);
+
+  oe_dirty(e);
 
   return change;
@@ -857,4 +877,5 @@
 
   e->goal_column = goal_column;
+  oe_dirty(e);
 
   return distance;
@@ -1211,5 +1232,4 @@
     return;
   }
-  owl_editwin_redisplay(e);
 }
 
@@ -1346,4 +1366,9 @@
 }
 
+static void oe_dirty(owl_editwin *e)
+{
+  if (e->win) owl_window_dirty(e->win);
+}
+
 
 
